/***************************************
	Auteur : Pierre Aubert
	Mail : pierre.aubert@lapp.in2p3.fr
	Licence : CeCILL-C
****************************************/
#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <random>

//Some doc at : https://en.cppreference.com/w/cpp/header/execution
#include <execution>
int main(int argc, char** argv){
	size_t nbElement(100000000);
	std::random_device rd{};
	std::mt19937 generator{rd()};
	std::normal_distribution distribNormal{0.0f, 1.0f};	//Mean = 0, Std = 1
	std::vector<float> tabX(nbElement), tabY(nbElement);
	std::for_each(tabX.begin(), tabX.end(),
		[&](float & val){
			val = distribNormal(generator);
		}
	);
	std::for_each(tabY.begin(), tabY.end(), 
		[&](float & val){
			val = distribNormal(generator);
		}
	);
	float res = std::transform_reduce(std::execution::par_unseq, std::begin(tabX), std::end(tabX), std::begin(tabY),
			0.0f, std::plus{},
			[](float xi, float yi){ return xi * yi; });
	std::cout << "res = " << res/((float)nbElement) << std::endl;
	return 0;
}

